#include "Keeper.h"
#include <czmq.h>
using namespace std;

Keeper::Keeper()
{
    map<string, map<string, double> > map_journal;
    time_calculate = 30000;
    time = zclock_time();
}

Keeper::~Keeper()
{
}

void Keeper::Insert_Message(pair<string, string> message)
{
    reader.parse(message.second, root, true);
    for (unsigned int i = 0; i < root.size(); i++) {
        Json::Value cur = root[i];
        string hostname = cur["hostname"].asString();
        double cpu_user = cur["change"]["cpu"]["user"].asDouble();
        double cpu_sys = cur["change"]["cpu"]["sys"].asDouble();
        double net_in = 0.0;
        double net_out = 0.0;
        for (unsigned int j = 0; j < cur["change"]["net"].size(); j++) {
            net_in += cur["change"]["net"][j]["bytes_in"].asDouble();
            net_out += cur["change"]["net"][j]["bytes_out"].asDouble();
        }
        double total = cur["static"]["mem"]["total"].asDouble();
        double mem_used = cur["static"]["mem"]["used"].asDouble();
        double buffer = cur["static"]["mem"]["buffer"].asDouble();
        double cached = cur["static"]["mem"]["cached"].asDouble();

        map<pair<string, string>, map<string, double> >::iterator iter = map_journal.find(pair<string, string>(message.first, hostname));
        if (iter == map_journal.end()) {
            map<string, double> map_param;
            map_param.insert(pair<string, double>("iter", 0.0));
            map_param.insert(pair<string, double>("cpu_user", cpu_user));
            map_param.insert(pair<string, double>("cpu_sys", cpu_sys));
            map_param.insert(pair<string, double>("net_in", net_in));
            map_param.insert(pair<string, double>("net_out", net_out));
            map_param.insert(pair<string, double>("total", total));
            map_param.insert(pair<string, double>("mem_used", mem_used));
            map_param.insert(pair<string, double>("buffer", buffer));
            map_param.insert(pair<string, double>("cached", cached));
            map_journal.insert(pair<pair<string, string>, map<string, double> >(pair<string, string>(message.first, hostname), map_param));
        }
        else {
            iter->second.find("iter")->second += 1;
            iter->second.find("cpu_user")->second += cpu_user;
            iter->second.find("cpu_sys")->second += cpu_sys;
            iter->second.find("net_in")->second += net_in;
            iter->second.find("net_out")->second += net_out;
            iter->second.find("total")->second += total;
            iter->second.find("mem_used")->second += mem_used;
            iter->second.find("buffer")->second += buffer;
            iter->second.find("cached")->second += cached;
        }
    }
}

map<pair<string, string>, map<string, double> > Keeper::Get_Map()
{
    for (map<pair<string, string>, map<string, double> >::iterator iter = map_journal.begin(); iter != map_journal.end(); iter++) {
        double count = iter->second.find("iter")->second;
        iter->second.find("cpu_user")->second /= count;
        iter->second.find("cpu_sys")->second /= count;
        iter->second.find("net_in")->second /= count;
        iter->second.find("net_out")->second /= count;
        iter->second.find("total")->second /= count;
        iter->second.find("mem_used")->second /= count;
        iter->second.find("buffer")->second /= count;
        iter->second.find("cached")->second /= count;
    }
    return map_journal;
}

bool Keeper::Time_Write()
{
    if ((zclock_time() - time) >= time_calculate) {
        time = zclock_time();
        return true;
    }
    else {
        return false;
    }
}

void Keeper::Set_Time_Calc(int time)
{
    time_calculate = time;
}

void Keeper::Clear_Map()
{
    map_journal.clear();
}