#include "Subscriber.h"

Subscriber::Subscriber(char* addr)
{
    addr_sub = addr;
}

Subscriber::Subscriber()
{
    addr_sub = strdup(">tcp://localhost:5001");
}

Subscriber::~Subscriber()
{
    zsock_destroy(&sub);
    free(addr_sub);
}

void Subscriber::Connect()
{
    sub = zsock_new_sub(addr_sub, "");
    printf("Subscriber is connected to %s\n", &addr_sub[1]);
}

void Subscriber::Set_Addr(char* addr)
{
    addr_sub = addr;
}

void Subscriber::Recv_Message()
{
    zmsg_t* msg = zmsg_recv(sub);
    if (msg) {
        char* sub_str = zmsg_popstr(msg);
        free(sub_str);
        char* clstr = zmsg_popstr(msg);
        char* jsn = zmsg_popstr(msg);
        cluster = clstr;
        json = jsn;
        free(clstr);
        free(jsn);
    }
    zmsg_destroy(&msg);
}

pair<string, string> Subscriber::Get_Cluster_Json()
{
    return pair<string, string>(cluster, json);
}